package importrest.api;

/* Maven Dependencies
	<dependency>
		<groupId>org.apache.httpcomponents</groupId>
		<artifactId>httpclient</artifactId>
		<version>4.3.4</version>
	</dependency>
	<!-- https://mvnrepository.com/artifact/org.apache.httpcomponents/httpmime -->
	<dependency>
		<groupId>org.apache.httpcomponents</groupId>
		<artifactId>httpmime</artifactId>
		<version>4.3.1</version>
	</dependency>
	<!-- https://mvnrepository.com/artifact/com.google.code.gson/gson -->
	<dependency>
		<groupId>com.google.code.gson</groupId>
		<artifactId>gson</artifactId>
		<version>2.8.0</version>
	</dependency>
*/

import java.io.File;
import java.io.IOException;

import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.entity.mime.MultipartEntityBuilder;
import org.apache.http.entity.mime.content.FileBody;
import org.apache.http.impl.client.CloseableHttpClient;
import org.apache.http.impl.client.HttpClients;
import org.apache.http.util.EntityUtils;
import com.google.gson.Gson;
import com.google.gson.GsonBuilder;
import com.google.gson.JsonElement;
import com.google.gson.JsonParser;

public class App {
	
	public static final String url = "https://testmanagement.qmetry.com/rest/import/createandscheduletestresults/1";
	
	
	// Mandatory Field
	public static File file = new File("RESULT FILE PATH");
	public static String entityType = "RESULT FILE FORMAT"; //Supported formats:TESTNG/CUCUMBER/JUNIT/HPUFT/QAF
	public static String projectID = "PROJET NAME/ID/KEY";
	public static final String apiKey = "ENTER OPEN API KEY";
	
	// important field
	// Find more details on below link
	// https://qmetrysupport.atlassian.net/wiki/spaces/QPro/pages/377094257/Import+Automation+Results+through+REST+API#ImportAutomationResultsthroughRESTAPI-AutomationAPIDetails

	public static String automationHierarchy;
	
	// Optional field				
	public static String cycleID;
	public static String platformID;
	public static String testsuiteId;
	public static String testsuiteName;	
	public static String releaseID;
	public static String buildID;
	//New Fields For Version 8.5.4
	public static String testCaseFields = "ENTER TEST CASE FIELDS IN JSON FORMAT" ;
	public static String testSuiteFields = "ENTER TEST SUITE FIELDS IN JSON FORMAT";
	
	public static void main(String[] args) throws ClientProtocolException, IOException {
		App.importTestsuite();
	}

	public static void importTestsuite()throws ClientProtocolException, IOException {

		CloseableHttpClient httpClient = HttpClients.createDefault();

		HttpPost httpPost = new HttpPost(url);
		httpPost.addHeader("apikey", apiKey);
		httpPost.addHeader("project", projectID);
		httpPost.addHeader("accept", "application/json");

		MultipartEntityBuilder builder = MultipartEntityBuilder.create();
		if (file != null && file.exists())
			builder.addPart("file", new FileBody(file));
		else {
			System.out.println("Upload file does not exist or not passed. Please provid valid file");
			return;
		}
		
		if (entityType != null)
			builder.addTextBody("entityType", entityType);
		else {
			System.out.println("Entity type required.");
			return;
		}
		if (cycleID != null)
			builder.addTextBody("cycleID", cycleID);
		if (platformID != null)
			builder.addTextBody("platformID", platformID);
		if (testsuiteId != null)
			builder.addTextBody("testsuiteId", testsuiteId);
		if (testsuiteName != null)
			builder.addTextBody("testsuiteName", testsuiteName);
		if (projectID != null)
			builder.addTextBody("projectID", projectID);
		if (releaseID != null)
			builder.addTextBody("releaseID", releaseID);
		if (buildID != null)
			builder.addTextBody("buildID", buildID);
		if (automationHierarchy != null)
			builder.addTextBody("automationHierarchy", automationHierarchy);
		if (testCaseFields != null && testCaseFields != "") {
			try{
				JsonParser parseTestCase = new JsonParser();
				parseTestCase.parse(testCaseFields);
				builder.addTextBody("testcase_fields", testCaseFields);
			}
			catch(Exception ex) {
				System.out.println("Enter valid JSON data in testCaseFields");
				System.exit(0);
			}
			
		}
			
		if (testSuiteFields != null && testSuiteFields != "") {
			try{
				JsonParser parseTestSuite = new JsonParser();
				parseTestSuite.parse(testSuiteFields);
				builder.addTextBody("testsuite_fields", testSuiteFields);
			}
			catch(Exception ex) {
				System.out.println("Enter valid JSON data in testSuiteFields");
				System.exit(0);
			}
			
		}
				
		HttpEntity httpEntity = builder.build();
		httpPost.setEntity(httpEntity);

		HttpResponse response = httpClient.execute(httpPost);
		HttpEntity entity = response.getEntity();

		String responseString = EntityUtils.toString(entity, "UTF-8");
		Gson gson = new GsonBuilder().setPrettyPrinting().create();
		JsonParser jp = new JsonParser();
		JsonElement je = jp.parse(responseString);
		String prettyJsonString = gson.toJson(je);
		System.out.println(prettyJsonString);
	}
}

